package org.xdoclet.plugin.struts.qtags;

public class StrutsValidatorArgsTagImpl extends org.xdoclet.XDocletTag implements org.xdoclet.plugin.struts.qtags.StrutsValidatorArgsTag {
    public static final String NAME = "struts.validator-args";
    private static final java.util.List ALLOWED_PARAMETERS = java.util.Arrays.asList( new String[] {
		"arg0value",
		"arg0resource",
		"arg1value",
		"arg1resource",
		"arg2value",
		"arg2resource",
		"arg3value",
		"arg3resource",
    	""
    });
    
    private static final java.util.List ALLOWED_VALUES = java.util.Arrays.asList( new String[] {
        ""
    });
    public StrutsValidatorArgsTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractJavaEntity entity, int lineNumber, org.xdoclet.QDoxPropertyExpander expander) {
        super(name, value, entity, lineNumber, expander);
    }
    public StrutsValidatorArgsTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractJavaEntity entity, int lineNumber) {
        super(name, value, entity, lineNumber);
    }

    public java.lang.String getArg0value() {
		boolean required = false;
        String result = getNamedParameter("arg0value");
        if(required && result == null) {
            bomb("arg0value=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getArg0resource() {
		boolean required = false;
        String result = getNamedParameter("arg0resource");
        if(required && result == null) {
            bomb("arg0resource=\"???\" must be specified.");
        }

		java.lang.String retVal = null;

        if(result == null) {
            result = "FormName.fieldName";
        }

		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getArg1value() {
		boolean required = false;
        String result = getNamedParameter("arg1value");
        if(required && result == null) {
            bomb("arg1value=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getArg1resource() {
		boolean required = false;
        String result = getNamedParameter("arg1resource");
        if(required && result == null) {
            bomb("arg1resource=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getArg2value() {
		boolean required = false;
        String result = getNamedParameter("arg2value");
        if(required && result == null) {
            bomb("arg2value=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getArg2resource() {
		boolean required = false;
        String result = getNamedParameter("arg2resource");
        if(required && result == null) {
            bomb("arg2resource=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getArg3value() {
		boolean required = false;
        String result = getNamedParameter("arg3value");
        if(required && result == null) {
            bomb("arg3value=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getArg3resource() {
		boolean required = false;
        String result = getNamedParameter("arg3resource");
        if(required && result == null) {
            bomb("arg3resource=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }

    protected void validateLocation() {
		if(isOnClass) {
        	bomb("is not allowed on classes");
		}
        if(isOnField) {
            bomb("is not allowed on fields");
        }
		if(isOnConstructor) {
        	bomb("is not allowed on constructors");
		}
        
        // check uniqueness

        // warn deprecation
        
        // check for allowed values for whole tag
        if( ALLOWED_VALUES.size() > 1 && !ALLOWED_VALUES.contains(getValue())) {
            bomb( "\"" + getValue() +"\" is not a valid value. Allowed values are ");
        }        
        // Verify that all parameters are known.
        final java.util.Collection parameterNames = getNamedParameterMap().keySet();
        for (java.util.Iterator iterator = parameterNames.iterator(); iterator.hasNext();) {
            String parameterName = (String) iterator.next();
            if (!ALLOWED_PARAMETERS.contains(parameterName)) {
                bomb(parameterName + " is an invalid parameter name.");
            }
        }
        
        // Get all the parameters to validate their contents
        getArg0value();
        getArg0resource();
        getArg1value();
        getArg1resource();
        getArg2value();
        getArg2resource();
        getArg3value();
        getArg3resource();
    }

    public void validateModel() {
        // check uniqueness
    }
}